#pragma once
#include <cstdint>
#include "!GlobalTypes.hpp"

///////////////////////////////////////////
// Binary: client.dll
// Class Count: 269
// Enum Count: 5
///////////////////////////////////////////

// Aligment: 4
// Size: 9
enum class NPC_STATE : uint32_t
{
	NPC_STATE_INVALID = 0xffffffffffffffff,
	NPC_STATE_NONE = 0x0,
	NPC_STATE_IDLE = 0x1,
	NPC_STATE_ALERT = 0x2,
	NPC_STATE_COMBAT = 0x3,
	NPC_STATE_SCRIPT = 0x4,
	NPC_STATE_PLAYDEAD = 0x5,
	NPC_STATE_PRONE = 0x6,
	NPC_STATE_DEAD = 0x7,
};

// Aligment: 4
// Size: 5
enum class C_BaseCombatCharacter::WaterWakeMode_t : uint32_t
{
	C_BaseCombatCharacter::WATER_WAKE_NONE = 0x0,
	C_BaseCombatCharacter::WATER_WAKE_IDLE = 0x1,
	C_BaseCombatCharacter::WATER_WAKE_WALKING = 0x2,
	C_BaseCombatCharacter::WATER_WAKE_RUNNING = 0x3,
	C_BaseCombatCharacter::WATER_WAKE_WATER_OVERHEAD = 0x4,
};

// Aligment: 4
// Size: 13
enum class PostProcessParameterNames_t : uint32_t
{
	PPPN_FADE_TIME = 0x0,
	PPPN_LOCAL_CONTRAST_STRENGTH = 0x1,
	PPPN_LOCAL_CONTRAST_EDGE_STRENGTH = 0x2,
	PPPN_VIGNETTE_START = 0x3,
	PPPN_VIGNETTE_END = 0x4,
	PPPN_VIGNETTE_BLUR_STRENGTH = 0x5,
	PPPN_FADE_TO_BLACK_STRENGTH = 0x6,
	PPPN_DEPTH_BLUR_FOCAL_DISTANCE = 0x7,
	PPPN_DEPTH_BLUR_STRENGTH = 0x8,
	PPPN_SCREEN_BLUR_STRENGTH = 0x9,
	PPPN_FILM_GRAIN_STRENGTH = 0xa,
	PPPN_TOP_VIGNETTE_STRENGTH = 0xb,
	POST_PROCESS_PARAMETER_COUNT = 0xc,
};

// Aligment: 4
// Size: 651
enum class GameActivity_t : uint32_t
{
	ACT_DCG_CARD_IDLE = 0x5dc,
	ACT_DCG_CARD_IDLE_FACEDOWN = 0x5dd,
	ACT_DCG_CARD_FLIP_BACK_TO_FRONT = 0x5de,
	ACT_DCG_CARD_FLIP_FRONT_TO_BACK = 0x5df,
	ACT_DCG_CARD_SHUFFLE = 0x5e0,
	ACT_DCG_CARD_SPIN = 0x5e1,
	ACT_DCG_CARD_SPIN_TO_BACK = 0x5e2,
	ACT_DCG_CARD_FLOP_FLIP_FACEUP = 0x5e3,
	ACT_DCG_CARD_COMBAT_COLLAPSE_LEFT = 0x5e4,
	ACT_DCG_CARD_COMBAT_COLLAPSE_RIGHT = 0x5e5,
	ACT_DCG_CARD_COMBAT_LOCAL_IDLE = 0x5e6,
	ACT_DCG_CARD_COMBAT_LOCAL_CLASH = 0x5e7,
	ACT_DCG_CARD_COMBAT_LOCAL_DEPLOY = 0x5e8,
	ACT_DCG_CARD_COMBAT_LOCAL_DEPLOY_MED = 0x5e9,
	ACT_DCG_CARD_COMBAT_LOCAL_RETURN = 0x5ea,
	ACT_DCG_CARD_COMBAT_LOCAL_STUNNED_CLASH = 0x5eb,
	ACT_DCG_CARD_COMBAT_LOCAL_STUNNED_RETURN = 0x5ec,
	ACT_DCG_CARD_COMBAT_LOCAL_STUNNED_RETURN_DAMAGED = 0x5ed,
	ACT_DCG_CARD_COMBAT_LOCAL_IMMUNE_CLASH = 0x5ee,
	ACT_DCG_CARD_COMBAT_LOCAL_IMMUNE_RETURN = 0x5ef,
	ACT_DCG_CARD_COMBAT_LOCAL_IMMUNE_RETURN_DAMAGED = 0x5f0,
	ACT_DCG_CARD_COMBAT_LOCAL_TOWER_RETURN = 0x5f1,
	ACT_DCG_CARD_COMBAT_LOCAL_TOWER_CLASH = 0x5f2,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_TO_FOUNTAIN = 0x5f3,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_CREEP = 0x5f4,
	ACT_DCG_CARD_COMBAT_OPPONENT_IDLE = 0x5f5,
	ACT_DCG_CARD_COMBAT_OPPONENT_CLASH = 0x5f6,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEPLOY = 0x5f7,
	ACT_DCG_CARD_COMBAT_OPPONENT_RETURN = 0x5f8,
	ACT_DCG_CARD_COMBAT_OPPONENT_STUNNED_CLASH = 0x5f9,
	ACT_DCG_CARD_COMBAT_OPPONENT_STUNNED_RETURN = 0x5fa,
	ACT_DCG_CARD_COMBAT_OPPONENT_STUNNED_RETURN_DAMAGED = 0x5fb,
	ACT_DCG_CARD_COMBAT_OPPONENT_IMMUNE_CLASH = 0x5fc,
	ACT_DCG_CARD_COMBAT_OPPONENT_IMMUNE_RETURN = 0x5fd,
	ACT_DCG_CARD_COMBAT_OPPONENT_IMMUNE_RETURN_DAMAGED = 0x5fe,
	ACT_DCG_CARD_COMBAT_OPPONENT_TOWER_CLASH = 0x5ff,
	ACT_DCG_CARD_COMBAT_OPPONENT_TOWER_RETURN = 0x600,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_TO_FOUNTAIN = 0x601,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_CREEP = 0x602,
	ACT_DCG_CARD_COMBAT_LOCAL_FLANK_LEFT_CLASH = 0x603,
	ACT_DCG_CARD_COMBAT_LOCAL_FLANK_RIGHT_CLASH = 0x604,
	ACT_DCG_CARD_COMBAT_LOCAL_FLANK_LEFT_RETURN = 0x605,
	ACT_DCG_CARD_COMBAT_LOCAL_FLANK_RIGHT_RETURN = 0x606,
	ACT_DCG_CARD_COMBAT_OPPONENT_FLANK_LEFT_CLASH = 0x607,
	ACT_DCG_CARD_COMBAT_OPPONENT_FLANK_RIGHT_CLASH = 0x608,
	ACT_DCG_CARD_COMBAT_OPPONENT_FLANK_LEFT_RETURN = 0x609,
	ACT_DCG_CARD_COMBAT_OPPONENT_FLANK_RIGHT_RETURN = 0x60a,
	ACT_DCG_CARD_SHARED_CREEP_DEPLOY = 0x60b,
	ACT_DCG_CARD_SHARED_LIFT_IDLE = 0x60c,
	ACT_DCG_CARD_SHARED_LIFT_INTRO = 0x60d,
	ACT_DCG_CARD_SHARED_LIFT_OUTRO = 0x60e,
	ACT_DCG_CARD_SHARED_DEPLOY_IMPACT = 0x60f,
	ACT_DCG_CARD_SHARED_DEPLOY_IMPACT_MED = 0x610,
	ACT_DCG_CARD_SHARED_RATTLE_HEAVY = 0x611,
	ACT_DCG_CARD_HAND_POP_UP = 0x612,
	ACT_DCG_CARD_HAND_POP_UP_IDLE = 0x613,
	ACT_DCG_CARD_HAND_POP_DOWN = 0x614,
	ACT_DCG_CARD_OPPONENT_HAND_POP_DOWN = 0x615,
	ACT_DCG_CARD_DRAG_HOVER_IDLE = 0x616,
	ACT_DCG_CARD_SWAP_NEIGHBOR_LEFT = 0x617,
	ACT_DCG_CARD_SWAP_NEIGHBOR_RIGHT = 0x618,
	ACT_DCG_CARD_HIGHLIGHT_POP_UP = 0x619,
	ACT_DCG_CARD_HIGHLIGHT_POP_UP_IDLE = 0x61a,
	ACT_DCG_CARD_HIGHLIGHT_POP_DOWN = 0x61b,
	ACT_DCG_CARD_SUIT_UP_LOCAL = 0x61c,
	ACT_DCG_CARD_SUIT_UP_OPPONENT = 0x61d,
	ACT_DCG_CARD_SUIT_UP_LOCAL_PRE_IDLE = 0x61e,
	ACT_DCG_CARD_SUIT_UP_OPPONENT_PRE_IDLE = 0x61f,
	ACT_DCG_CARD_SUIT_UP_LOCAL_IDLE = 0x620,
	ACT_DCG_CARD_SUIT_UP_OPPONENT_IDLE = 0x621,
	ACT_DCG_CARD_INSPECT = 0x622,
	ACT_DCG_CARD_INSPECT_IDLE = 0x623,
	ACT_DCG_CARD_SPELL_STACK_ENTER = 0x624,
	ACT_DCG_CARD_SPELL_STACK_ENTER_LOCAL = 0x625,
	ACT_DCG_CARD_SPELL_STACK_EXIT = 0x626,
	ACT_DCG_CARD_SPELL_STACK_IDLE_OPP = 0x627,
	ACT_DCG_CARD_SPELL_STACK_IDLE_LOCAL = 0x628,
	ACT_DCG_CARD_SWAP_NEIGHBOR_RIGHT_TO_LEFT = 0x629,
	ACT_DCG_CARD_SWAP_NEIGHBOR_LEFT_TO_RIGHT = 0x62a,
	ACT_DCG_CARD_SWAP_NEIGHBOR_RIGHT_TO_LEFT_STATIC = 0x62b,
	ACT_DCG_CARD_SWAP_NEIGHBOR_LEFT_TO_RIGHT_STATIC = 0x62c,
	ACT_DCG_CARD_ATTACK_NEIGHBOR_RIGHT = 0x62d,
	ACT_DCG_CARD_ATTACK_NEIGHBOR_LEFT = 0x62e,
	ACT_DCG_CARD_ROT_360_HORIZ = 0x62f,
	ACT_DCG_CARD_ROT_360_VERT_L_TO_R = 0x630,
	ACT_DCG_CARD_ROT_360_VERT_R_TO_L = 0x631,
	ACT_DCG_CARD_TURN_FLOP = 0x632,
	ACT_DCG_CARD_DRAW_SINGLE = 0x633,
	ACT_DCG_CARD_DRAW_SINGLE_OPPONENT = 0x634,
	ACT_DCG_CARD_DRAW_MULTI = 0x635,
	ACT_DCG_CARD_DRAW_MULTI_OPPONENT = 0x636,
	ACT_DECK_IMP_OPPONENT_NO_UNITS_BROAD = 0x637,
	ACT_DECK_IMP_REACT_LAUGHT_AT_OPPONENT = 0x638,
	ACT_kDCG_CARD_EFFECT_DAMAGE_THUNDERGODSWRATH = 0x639,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK1 = 0x63a,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK2 = 0x63b,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK3 = 0x63c,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK4 = 0x63d,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK5 = 0x63e,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK6 = 0x63f,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK7 = 0x640,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK8 = 0x641,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK9 = 0x642,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK10 = 0x643,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK1 = 0x644,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK2 = 0x645,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK3 = 0x646,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK4 = 0x647,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK5 = 0x648,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK6 = 0x649,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK7 = 0x64a,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK8 = 0x64b,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK9 = 0x64c,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK10 = 0x64d,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK1_TO_FOUNTAIN1 = 0x64e,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK2_TO_FOUNTAIN2 = 0x64f,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK3_TO_FOUNTAIN3 = 0x650,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK4_TO_FOUNTAIN4 = 0x651,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK5_TO_FOUNTAIN5 = 0x652,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK6_TO_FOUNTAIN6 = 0x653,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK7_TO_FOUNTAIN7 = 0x654,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK8_TO_FOUNTAIN8 = 0x655,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK9_TO_FOUNTAIN9 = 0x656,
	ACT_DCG_CARD_COMBAT_LOCAL_DEATH_HERO_RACK10_TO_FOUNTAIN10 = 0x657,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK1_TO_FOUNTAIN1 = 0x658,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK2_TO_FOUNTAIN2 = 0x659,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK3_TO_FOUNTAIN3 = 0x65a,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK4_TO_FOUNTAIN4 = 0x65b,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK5_TO_FOUNTAIN5 = 0x65c,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK6_TO_FOUNTAIN6 = 0x65d,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK7_TO_FOUNTAIN7 = 0x65e,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK8_TO_FOUNTAIN8 = 0x65f,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK9_TO_FOUNTAIN9 = 0x660,
	ACT_DCG_CARD_COMBAT_OPPONENT_DEATH_HERO_RACK10_TO_FOUNTAIN10 = 0x661,
	ACT_DCG_CARD_HIT_REACTION_LOCAL = 0x662,
	ACT_DCG_CARD_HIT_REACTION_OPPONENT = 0x663,
	ACT_DCG_CARD_SPRINGTRAP_LOCAL_DEPLOY = 0x664,
	ACT_DCG_CARD_SPRINGTRAP_OPPONENT_DEPLOY = 0x665,
	ACT_DCG_CARD_TERRIFY_SHARED = 0x666,
	ACT_DCG_CARD_FISSURE_SHARED = 0x667,
	ACT_DCG_CARD_PREY_WEAK_SHARED = 0x668,
	ACT_DCG_CARD_ROUTED_SHARED = 0x669,
	ACT_DCG_CARD_WHIRLING_DEATH_LOCAL = 0x66a,
	ACT_DCG_CARD_WHIRLING_DEATH_OPPONENT = 0x66b,
	ACT_DCG_CARD_WHIRLING_DEATH_IMPACT = 0x66c,
	ACT_DCG_CARD_HACK_SPELLSTACK = 0x66d,
	ACT_DCG_CARD_HACK_SPELLSTACK_OPP = 0x66e,
	ACT_DCG_CARD_GOLDEN_TICKET_SPELLSTACK = 0x66f,
	ACT_DCG_CARD_GOLDEN_TICKET_SPELLSTACK_OPP = 0x670,
	ACT_DCG_CARD_GOLDEN_TICKET_IDLE = 0x671,
	ACT_DCG_CARD_SPELLSTACK_OPP = 0x672,
	ACT_DCG_CARD_SPELLSTACK_LOCAL = 0x673,
	ACT_DCG_CARD_VENTRILOQUY = 0x674,
	ACT_DCG_CARD_COUP_DE_GRACE_LIFT = 0x675,
	ACT_DCG_CARD_COUP_DE_GRACE_SLASH = 0x676,
	ACT_DCG_CARD_COUP_DE_GRACE_RECLAIM = 0x677,
	ACT_DCG_CARD_GANK_SLASH = 0x678,
	ACT_DCG_CARD_GANK_SLASH_TARGET = 0x679,
	ACT_DCG_CARD_FOUNTAIN_INTRO = 0x67a,
	ACT_DCG_CARD_FOUNTAIN_IDLE = 0x67b,
	ACT_DCG_CARD_FOUNTAIN_OUTRO = 0x67c,
	ACT_DCG_CARD_COMBATARROW_M_IDLE = 0x67d,
	ACT_DCG_CARD_COMBATARROW_R_IDLE = 0x67e,
	ACT_DCG_CARD_COMBATARROW_L_IDLE = 0x67f,
	ACT_DCG_CARD_COMBATARROW_M_R = 0x680,
	ACT_DCG_CARD_COMBATARROW_R_L = 0x681,
	ACT_DCG_CARD_COMBATARROW_R_M = 0x682,
	ACT_DCG_CARD_COMBATARROW_L_M = 0x683,
	ACT_DCG_CARD_COMBATARROW_M_L = 0x684,
	ACT_DCG_CARD_COMBATARROW_L_R = 0x685,
	ACT_DCG_CARD_PACKOPENING_REVEAL = 0x686,
	ACT_DCG_CARD_PACKOPENING_IDLE = 0x687,
	ACT_DCG_CARD_PACKOPENING_IDLE_FACEDOWN = 0x688,
	ACT_DCG_CARD_PACKOPENING_HOVER = 0x689,
	ACT_DCG_CARD_PACKOPENING_RARE_REVEAL = 0x68a,
	ACT_DCG_CARD_PACKOPENING_RARE_HOVER = 0x68b,
	ACT_PACK_OPENING_HOVER = 0x68c,
	ACT_PACK_OPENING_IDLE = 0x68d,
	ACT_PACK_OPENING_OPEN = 0x68e,
	ACT_PACK_OPENING_OPEN_IDLE = 0x68f,
	ACT_PACK_OPENING_OPEN_NPE = 0x690,
	ACT_PACK_OPENING_OPEN_IDLE_NPE = 0x691,
	ACT_PACK_OPENING_OUTRO = 0x692,
	ACT_PACK_OPENING_INTRO = 0x693,
	ACT_DCG_CARD_PACKOPENING_INCLUDE_1 = 0x694,
	ACT_DCG_CARD_PACKOPENING_INCLUDE_2 = 0x695,
	ACT_DCG_CARD_PACKOPENING_INCLUDE_3 = 0x696,
	ACT_DCG_CARD_PACKOPENING_INCLUDE_HOVER_1 = 0x697,
	ACT_DCG_CARD_PACKOPENING_INCLUDE_HOVER_2 = 0x698,
	ACT_DCG_CARD_PACKOPENING_INCLUDE_HOVER_3 = 0x699,
	ACT_DCG_TOWER_IDLE_LOCAL = 0x69a,
	ACT_DCG_TOWER_IDLE_LOCAL_STRATEGIC_LEFT = 0x69b,
	ACT_DCG_TOWER_IDLE_LOCAL_STRATEGIC_LEFT_TRANSITION = 0x69c,
	ACT_DCG_TOWER_IDLE_LOCAL_STRATEGIC_LEFT_RETURN = 0x69d,
	ACT_DCG_TOWER_IDLE_LOCAL_STRATEGIC_RIGHT = 0x69e,
	ACT_DCG_TOWER_IDLE_LOCAL_STRATEGIC_RIGHT_TRANSITION = 0x69f,
	ACT_DCG_TOWER_IDLE_LOCAL_STRATEGIC_RIGHT_RETURN = 0x6a0,
	ACT_DCG_TOWER_IDLE_OPPONENT = 0x6a1,
	ACT_DCG_TOWER_IDLE_OPPONENT_STRATEGIC_LEFT = 0x6a2,
	ACT_DCG_TOWER_IDLE_OPPONENT_STRATEGIC_LEFT_TRANSITION = 0x6a3,
	ACT_DCG_TOWER_IDLE_OPPONENT_STRATEGIC_LEFT_RETURN = 0x6a4,
	ACT_DCG_TOWER_IDLE_OPPONENT_STRATEGIC_RIGHT = 0x6a5,
	ACT_DCG_TOWER_IDLE_OPPONENT_STRATEGIC_RIGHT_TRANSITION = 0x6a6,
	ACT_DCG_TOWER_IDLE_OPPONENT_STRATEGIC_RIGHT_RETURN = 0x6a7,
	ACT_DCG_TOWER_HIT_LOCAL = 0x6a8,
	ACT_DCG_TOWER_HIT_LOW_LOCAL = 0x6a9,
	ACT_DCG_TOWER_HIT_OPPONENT = 0x6aa,
	ACT_DCG_TOWER_HIT_LOW_OPPONENT = 0x6ab,
	ACT_DCG_TOWER_DESTRUCTION_LVL1 = 0x6ac,
	ACT_DCG_TOWER_DESTRUCTION_FINAL = 0x6ad,
	ACT_DCG_TOWER_DESTRUCTION_LOCAL = 0x6ae,
	ACT_DCG_TOWER_DESTRUCTION_FX_LOCAL = 0x6af,
	ACT_DCG_TOWER_DESTRUCTION_OPPONENT = 0x6b0,
	ACT_DCG_TOWER_WAKE_LOCAL = 0x6b1,
	ACT_DCG_TOWER_SLEEP_LOCAL = 0x6b2,
	ACT_DCG_TOWER_WAKE_OPPONENT = 0x6b3,
	ACT_DCG_TOWER_SLEEP_OPPONENT = 0x6b4,
	ACT_DCG_TOWER_DIRE_ARMOR_LOCAL_STRATEGY = 0x6b5,
	ACT_DCG_TOWER_DIRE_ARMOR_OPPONENT_STRATEGY = 0x6b6,
	ACT_DCG_TOWER_DIRE_ANCIENT_ARMOR_LOCAL_STRATEGY = 0x6b7,
	ACT_DCG_TOWER_DIRE_ANCIENT_ARMOR_OPPONENT_STRATEGY = 0x6b8,
	ACT_DCG_TOWER_RADIANT_ARMOR_LOCAL_STRATEGY = 0x6b9,
	ACT_DCG_TOWER_RADIANT_ARMOR_OPPONENT_STRATEGY = 0x6ba,
	ACT_DCG_TOWER_RADIANT_ANCIENT_ARMOR_LOCAL_STRATEGY = 0x6bb,
	ACT_DCG_TOWER_RADIANT_ANCIENT_ARMOR_OPPONENT_STRATEGY = 0x6bc,
	ACT_DCG_TOWER_DIRE_ARMOR_LOCAL_STRATEGY_REVERSE = 0x6bd,
	ACT_DCG_TOWER_DIRE_ARMOR_OPPONENT_STRATEGY_REVERSE = 0x6be,
	ACT_DCG_TOWER_DIRE_ANCIENT_ARMOR_LOCAL_STRATEGY_REVERSE = 0x6bf,
	ACT_DCG_TOWER_DIRE_ANCIENT_ARMOR_OPPONENT_STRATEGY_REVERSE = 0x6c0,
	ACT_DCG_TOWER_RADIANT_ARMOR_LOCAL_STRATEGY_REVERSE = 0x6c1,
	ACT_DCG_TOWER_RADIANT_ARMOR_OPPONENT_STRATEGY_REVERSE = 0x6c2,
	ACT_DCG_TOWER_RADIANT_ANCIENT_ARMOR_LOCAL_STRATEGY_REVERSE = 0x6c3,
	ACT_DCG_TOWER_RADIANT_ANCIENT_ARMOR_OPPONENT_STRATEGY_REVERSE = 0x6c4,
	ACT_DCG_CARD_BLINK_REST_TO_IDLE = 0x6c5,
	ACT_DCG_CARD_BLINK_START = 0x6c6,
	ACT_DCG_CARD_BLINK_IDLE = 0x6c7,
	ACT_DCG_CARD_BLINK_END = 0x6c8,
	ACT_DCG_CARD_RAVAGE_IMPACT = 0x6c9,
	ACT_DCG_CARD_ENOUGH_MAGIC = 0x6ca,
	ACT_DCG_ROSHAN_TIME_OF_TRIUMPH = 0x6cb,
	ACT_DCG_SHIELD_LEFT_DEPLOY = 0x6cc,
	ACT_DCG_SHIELD_LEFT_IDLE = 0x6cd,
	ACT_DCG_SHIELD_LEFT_RETRACT = 0x6ce,
	ACT_DCG_SHIELD_LEFT_STOMPED = 0x6cf,
	ACT_DCG_SHIELD_RIGHT_DEPLOY = 0x6d0,
	ACT_DCG_SHIELD_RIGHT_IDLE = 0x6d1,
	ACT_DCG_SHIELD_RIGHT_RETRACT = 0x6d2,
	ACT_DCG_SHIELD_RIGHT_STOMPED = 0x6d3,
	ACT_DCG_CARD_ROLL_FOR_SHIELDS = 0x6d4,
	ACT_CAMERA_LANE1_IDLE = 0x6d5,
	ACT_CAMERA_LANE2_IDLE = 0x6d6,
	ACT_CAMERA_LANE3_IDLE = 0x6d7,
	ACT_CAMERA_MASTER_IDLE = 0x6d8,
	ACT_CAMERA_SHOP_IDLE = 0x6d9,
	ACT_CAMERA_STRATEGIC_IDLE = 0x6da,
	ACT_CAMERA_LANE1_TO_LANE2_USER = 0x6db,
	ACT_CAMERA_LANE1_TO_LANE3_USER = 0x6dc,
	ACT_CAMERA_LANE1_TO_STRATEGIC_USER = 0x6dd,
	ACT_CAMERA_LANE2_TO_LANE1_USER = 0x6de,
	ACT_CAMERA_LANE2_TO_LANE3_USER = 0x6df,
	ACT_CAMERA_LANE2_TO_STRATEGIC_USER = 0x6e0,
	ACT_CAMERA_LANE3_TO_LANE2_USER = 0x6e1,
	ACT_CAMERA_LANE3_TO_LANE1_USER = 0x6e2,
	ACT_CAMERA_LANE3_TO_STRATEGIC_USER = 0x6e3,
	ACT_CAMERA_STRATEGIC_TO_LANE1_USER = 0x6e4,
	ACT_CAMERA_STRATEGIC_TO_LANE2_USER = 0x6e5,
	ACT_CAMERA_STRATEGIC_TO_LANE3_USER = 0x6e6,
	ACT_CAMERA_LANE1_TO_LANE2_COMBAT_END = 0x6e7,
	ACT_CAMERA_LANE2_TO_LANE3_COMBAT_END = 0x6e8,
	ACT_CAMERA_LANE3_TO_STRATEGIC_COMBAT_END = 0x6e9,
	ACT_CAMERA_MASTER_TO_STRATEGIC = 0x6ea,
	ACT_CAMERA_SHOP_TO_STRATEGIC = 0x6eb,
	ACT_CAMERA_STRATEGIC_TO_LANE1 = 0x6ec,
	ACT_CAMERA_STRATEGIC_TO_SHOP = 0x6ed,
	ACT_CAMERA_GAME_START = 0x6ee,
	ACT_CAMERA_GAME_START_TO_STRATEGIC = 0x6ef,
	ACT_CAMERA_THUNDERGODSWRATH = 0x6f0,
	ACT_CAMERA_THUNDERGODSWRATH_V2 = 0x6f1,
	ACT_CAMERA_LANE1_TIME_OF_TRIUMPH_TILT_UP = 0x6f2,
	ACT_CAMERA_LANE1_TIME_OF_TRIUMPH_IDLE = 0x6f3,
	ACT_CAMERA_LANE1_TIME_OF_TRIUMPH_TILT_DOWN = 0x6f4,
	ACT_CAMERA_LANE2_TIME_OF_TRIUMPH_TILT_UP = 0x6f5,
	ACT_CAMERA_LANE2_TIME_OF_TRIUMPH_IDLE = 0x6f6,
	ACT_CAMERA_LANE2_TIME_OF_TRIUMPH_TILT_DOWN = 0x6f7,
	ACT_CAMERA_LANE3_TIME_OF_TRIUMPH_TILT_UP = 0x6f8,
	ACT_CAMERA_LANE3_TIME_OF_TRIUMPH_IDLE = 0x6f9,
	ACT_CAMERA_LANE3_TIME_OF_TRIUMPH_TILT_DOWN = 0x6fa,
	ACT_CAMERA_LANE1_BOLT_OF_DAMOCLES_IN = 0x6fb,
	ACT_CAMERA_LANE2_BOLT_OF_DAMOCLES_IN = 0x6fc,
	ACT_CAMERA_LANE3_BOLT_OF_DAMOCLES_IN = 0x6fd,
	ACT_CAMERA_LANE1_BOLT_OF_DAMOCLES_IN_OPP = 0x6fe,
	ACT_CAMERA_LANE2_BOLT_OF_DAMOCLES_IN_OPP = 0x6ff,
	ACT_CAMERA_LANE3_BOLT_OF_DAMOCLES_IN_OPP = 0x700,
	ACT_CAMERA_LANE1_BOLT_OF_DAMOCLES_OUT = 0x701,
	ACT_CAMERA_LANE2_BOLT_OF_DAMOCLES_OUT = 0x702,
	ACT_CAMERA_LANE3_BOLT_OF_DAMOCLES_OUT = 0x703,
	ACT_CAMERA_LANE1_BOLT_OF_DAMOCLES_OUT_OPP = 0x704,
	ACT_CAMERA_LANE2_BOLT_OF_DAMOCLES_OUT_OPP = 0x705,
	ACT_CAMERA_LANE3_BOLT_OF_DAMOCLES_OUT_OPP = 0x706,
	ACT_CAMERA_SPELLCAST_LANE_1_IDLE = 0x707,
	ACT_CAMERA_SPELLCAST_LANE_2_IDLE = 0x708,
	ACT_CAMERA_SPELLCAST_LANE_3_IDLE = 0x709,
	ACT_CAMERA_SPELLCAST_LANE_1_TO_2 = 0x70a,
	ACT_CAMERA_SPELLCAST_LANE_2_TO_3 = 0x70b,
	ACT_CAMERA_SPELLCAST_LANE_3_TO_2 = 0x70c,
	ACT_CAMERA_SPELLCAST_LANE_2_TO_1 = 0x70d,
	ACT_CAMERA_LANE_1_COMBAT = 0x70e,
	ACT_CAMERA_LANE_2_COMBAT = 0x70f,
	ACT_CAMERA_LANE_3_COMBAT = 0x710,
	ACT_CAMERA_LANE1_TOWER_DESTRUCTION_PUSH_IN_OPPONENT = 0x711,
	ACT_CAMERA_LANE1_TOWER_DESTRUCTION_DRIFT_OPPONENT = 0x712,
	ACT_CAMERA_LANE1_TOWER_DESTRUCTION_PULL_OUT_OPPONENT = 0x713,
	ACT_CAMERA_LANE2_TOWER_DESTRUCTION_PUSH_IN_OPPONENT = 0x714,
	ACT_CAMERA_LANE2_TOWER_DESTRUCTION_DRIFT_OPPONENT = 0x715,
	ACT_CAMERA_LANE2_TOWER_DESTRUCTION_PULL_OUT_OPPONENT = 0x716,
	ACT_CAMERA_LANE3_TOWER_DESTRUCTION_PUSH_IN_OPPONENT = 0x717,
	ACT_CAMERA_LANE3_TOWER_DESTRUCTION_DRIFT_OPPONENT = 0x718,
	ACT_CAMERA_LANE3_TOWER_DESTRUCTION_PULL_OUT_OPPONENT = 0x719,
	ACT_CAMERA_LANE1_TOWER_DESTRUCTION_PUSH_IN_PLAYER = 0x71a,
	ACT_CAMERA_LANE1_TOWER_DESTRUCTION_DRIFT_PLAYER = 0x71b,
	ACT_CAMERA_LANE1_TOWER_DESTRUCTION_PULL_OUT_PLAYER = 0x71c,
	ACT_CAMERA_LANE2_TOWER_DESTRUCTION_PUSH_IN_PLAYER = 0x71d,
	ACT_CAMERA_LANE2_TOWER_DESTRUCTION_DRIFT_PLAYER = 0x71e,
	ACT_CAMERA_LANE2_TOWER_DESTRUCTION_PULL_OUT_PLAYER = 0x71f,
	ACT_CAMERA_LANE3_TOWER_DESTRUCTION_PUSH_IN_PLAYER = 0x720,
	ACT_CAMERA_LANE3_TOWER_DESTRUCTION_DRIFT_PLAYER = 0x721,
	ACT_CAMERA_LANE3_TOWER_DESTRUCTION_PULL_OUT_PLAYER = 0x722,
	ACT_CAMERA_LANE1_TOWER_DESTRUCTION_OPPONENT = 0x723,
	ACT_CAMERA_LANE1_TOWER_DESTRUCTION_PLAYER = 0x724,
	ACT_CAMERA_LANE2_TOWER_DESTRUCTION_OPPONENT = 0x725,
	ACT_CAMERA_LANE2_TOWER_DESTRUCTION_PLAYER = 0x726,
	ACT_CAMERA_LANE3_TOWER_DESTRUCTION_OPPONENT = 0x727,
	ACT_CAMERA_LANE3_TOWER_DESTRUCTION_PLAYER = 0x728,
	ACT_CAMERA_LANE1_ANCIENT_DESTRUCTION_OPPONENT = 0x729,
	ACT_CAMERA_LANE1_ANCIENT_DESTRUCTION_PLAYER = 0x72a,
	ACT_CAMERA_LANE2_ANCIENT_DESTRUCTION_OPPONENT = 0x72b,
	ACT_CAMERA_LANE2_ANCIENT_DESTRUCTION_PLAYER = 0x72c,
	ACT_CAMERA_LANE3_ANCIENT_DESTRUCTION_OPPONENT = 0x72d,
	ACT_CAMERA_LANE3_ANCIENT_DESTRUCTION_PLAYER = 0x72e,
	ACT_CAMERA_VICTORY_LANE_1 = 0x72f,
	ACT_CAMERA_VICTORY_LANE_1_IDLE = 0x730,
	ACT_CAMERA_VICTORY_LANE_2 = 0x731,
	ACT_CAMERA_VICTORY_LANE_2_IDLE = 0x732,
	ACT_CAMERA_VICTORY_LANE_3 = 0x733,
	ACT_CAMERA_VICTORY_LANE_3_IDLE = 0x734,
	ACT_CAMERA_DEFEAT_LANE_1 = 0x735,
	ACT_CAMERA_DEFEAT_LANE_1_IDLE = 0x736,
	ACT_CAMERA_DEFEAT_LANE_2 = 0x737,
	ACT_CAMERA_DEFEAT_LANE_2_IDLE = 0x738,
	ACT_CAMERA_DEFEAT_LANE_3 = 0x739,
	ACT_CAMERA_DEFEAT_LANE_3_IDLE = 0x73a,
	ACT_CAMERA_FIVE_V_FIVE_REVEAL = 0x73b,
	ACT_SHOP_APPEAR_MAXIMIZED = 0x73c,
	ACT_SHOP_APPEAR_MAXIMIZED_TRIGGER = 0x73d,
	ACT_SHOP_OPPONENT_SHOP_APPEAR_MAXIMIZED = 0x73e,
	ACT_SHOP_COIN_APPEAR_MAXIMIZED = 0x73f,
	ACT_SHOP_PLAYER_IMP_APPEAR_MAXIMIZED = 0x740,
	ACT_SHOP_OPPONENT_SHOP_OPPONENT_IMP_APPEAR_MAXIMIZED = 0x741,
	ACT_SHOP_MAXIMIZED_IDLE = 0x742,
	ACT_SHOP_PLAYER_IMP_MAXIMIZED_IDLE = 0x743,
	ACT_SHOP_COIN_MAXIMIZED_IDLE = 0x744,
	ACT_SHOP_APPEAR_MINIMIZED = 0x745,
	ACT_SHOP_FINISH_SHOPPING_MAXIMIZED = 0x746,
	ACT_SHOP_FINISH_SHOPPING_MINIMIZED = 0x747,
	ACT_SHOP_MAXIMIZE = 0x748,
	ACT_SHOP_MINIMIZE = 0x749,
	ACT_SHOP_IMP_MINIMIZE = 0x74a,
	ACT_SHOP_COIN_MINIMIZE = 0x74b,
	ACT_SHOP_MINIMIZED_IDLE = 0x74c,
	ACT_SHOP_IMP_MINIMIZED_IDLE = 0x74d,
	ACT_SHOP_COIN_MINIMIZED_IDLE = 0x74e,
	ACT_SHOP_IMP_MAXIMIZE = 0x74f,
	ACT_SHOP_COIN_MAXIMIZE = 0x750,
	ACT_SHOP_LANE_TO_STRATEGIC = 0x751,
	ACT_SHOP_STRATEGIC_TO_LANE = 0x752,
	ACT_SHOP_MOVE_LEFT_LANE = 0x753,
	ACT_SHOP_MOVE_RIGHT_LANE = 0x754,
	ACT_SHOP_HIDDEN = 0x755,
	ACT_SHOP_ON_TABLE_IDLE = 0x756,
	ACT_OPPONENT_SHOP_ON_TABLE_IDLE = 0x757,
	ACT_SHOP_FINISH_SHOPPING = 0x758,
	ACT_SHOP_OPPONENT_SHOP_FINISH_SHOPPING = 0x759,
	ACT_SHOP_IMP_SUIT_UP_IDLE = 0x75a,
	ACT_SHOP_IMP_DEAL_CREEPS_TO_SUIT_UP_IDLE = 0x75b,
	ACT_SHOP_IMP_DEAL_CREEPS = 0x75c,
	ACT_SHOP_IMP_FINISH_SHOPPING = 0x75d,
	ACT_SHOP_OPPONENT_IMP_SUIT_UP_IDLE = 0x75e,
	ACT_SHOP_OPPONENT_IMP_DEAL_CREEPS_TO_SUIT_UP_IDLE = 0x75f,
	ACT_SHOP_OPPONENT_IMP_DEAL_CREEPS = 0x760,
	ACT_SHOP_OPPONENT_IMP_FINISH_SHOPPING = 0x761,
	ACT_FLOP_IMP_COMMIT_COIN_INTRO = 0x762,
	ACT_FLOP_IMP_COMMIT_COIN_LOOP = 0x763,
	ACT_FLOP_OPPONENT_IMP_COMMIT_COIN_INTRO = 0x764,
	ACT_FLOP_IMP_DEPLOY_COMMIT = 0x765,
	ACT_FLOP_IMP_DEAL_PATHING_LOOP = 0x766,
	ACT_FLOP_IMP_DEAL_PATHING_TO_IDLE = 0x767,
	ACT_FLOP_IMP_PATHING_DECK_IDLE = 0x768,
	ACT_FLOP_OPPONENT_IMP_DEPLOY_COMMIT = 0x769,
	ACT_FLOP_OPPONENT_IMP_DEAL_PATHING_LOOP = 0x76a,
	ACT_FLOP_OPPONENT_IMP_DEAL_PATHING_TO_IDLE = 0x76b,
	ACT_FLOP_OPPONENT_IMP_PATHING_DECK_IDLE = 0x76c,
	ACT_FLOP_IMP_SHUFFLE_INTRO_LANE_1 = 0x76d,
	ACT_FLOP_IMP_SHUFFLE_LANE_1 = 0x76e,
	ACT_FLOP_IMP_SHUFFLE_FLOP_LANE_1 = 0x76f,
	ACT_FLOP_IMP_SHUFFLE_INTRO_LANE_2 = 0x770,
	ACT_FLOP_IMP_SHUFFLE_LANE_2 = 0x771,
	ACT_FLOP_IMP_SHUFFLE_FLOP_LANE_2 = 0x772,
	ACT_FLOP_IMP_SHUFFLE_INTRO_LANE_3 = 0x773,
	ACT_FLOP_IMP_SHUFFLE_LANE_3 = 0x774,
	ACT_FLOP_IMP_SHUFFLE_FLOP_LANE_3 = 0x775,
	ACT_FLOP_IMP_SHUFFLE_RETURN_TO_LANE_1 = 0x776,
	ACT_FLOP_OPPONENT_IMP_SHUFFLE_INTRO_LANE_1 = 0x777,
	ACT_FLOP_OPPONENT_IMP_SHUFFLE_LANE_1 = 0x778,
	ACT_FLOP_OPPONENT_IMP_SHUFFLE_FLOP_LANE_1 = 0x779,
	ACT_FLOP_OPPONENT_IMP_SHUFFLE_INTRO_LANE_2 = 0x77a,
	ACT_FLOP_OPPONENT_IMP_SHUFFLE_LANE_2 = 0x77b,
	ACT_FLOP_OPPONENT_IMP_SHUFFLE_FLOP_LANE_2 = 0x77c,
	ACT_FLOP_OPPONENT_IMP_SHUFFLE_INTRO_LANE_3 = 0x77d,
	ACT_FLOP_OPPONENT_IMP_SHUFFLE_LANE_3 = 0x77e,
	ACT_FLOP_OPPONENT_IMP_SHUFFLE_FLOP_LANE_3 = 0x77f,
	ACT_FLOP_OPPONENT_IMP_SHUFFLE_RETURN_TO_LANE_1 = 0x780,
	ACT_SHOP_CARD_PANEL_IDLE_LOCKED = 0x781,
	ACT_SHOP_CARD_PANEL_IDLE_UNLOCKED = 0x782,
	ACT_SHOP_CARD_PANEL_FLIP_LOCKED = 0x783,
	ACT_SHOP_CARD_PANEL_FLIP_UNLOCKED = 0x784,
	ACT_SHOP_CARD_PANEL_LOCK = 0x785,
	ACT_SHOP_CARD_PANEL_UNLOCK = 0x786,
	ACT_FLOP_IMP_SHUFFLE_AND_FLOP_RETURN_TO_LANE_1 = 0x787,
	ACT_FLOP_IMP_SHUFFLE_AND_FLOP_LANE_1 = 0x788,
	ACT_FLOP_IMP_SHUFFLE_AND_FLOP_LANE_2 = 0x789,
	ACT_FLOP_IMP_SHUFFLE_AND_FLOP_LANE_3 = 0x78a,
	ACT_DECK_IMP_IDLE = 0x78b,
	ACT_DECK_IMP_IDLE_OPPONENT = 0x78c,
	ACT_DECK_IMP_IDLE_VARIANT = 0x78d,
	ACT_DECK_IMP_FLY_ADVANCE_LANE = 0x78e,
	ACT_DECK_IMP_FLY_LANE3_TO_LANE1 = 0x78f,
	ACT_DECK_IMP_FLY_ADVANCE_LANE_OPPONENT = 0x790,
	ACT_DECK_IMP_FLY_LANE3_TO_LANE1_OPPONENT = 0x791,
	ACT_DECK_IMP_SPAWN = 0x792,
	ACT_DECK_IMP_SPAWN_OPPONENT = 0x793,
	ACT_DECK_IMP_TAUNT = 0x794,
	ACT_DECK_IMP_COMPLEMENT = 0x795,
	ACT_DECK_IMP_CELEBRATE = 0x796,
	ACT_DECK_IMP_DEFEAT = 0x797,
	ACT_DECK_IMP_PASS_TURN = 0x798,
	ACT_DECK_IMP_RECEIVE_TURN = 0x799,
	ACT_DECK_IMP_COMBAT = 0x79a,
	ACT_DECK_IMP_COMBAT_OPPONENT = 0x79b,
	ACT_DECK_IMP_DEAL_SINGLE = 0x79c,
	ACT_DECK_IMP_DEAL_SINGLE_OPPONENT = 0x79d,
	ACT_DECK_IMP_DEAL_MULTI_START = 0x79e,
	ACT_DECK_IMP_DEAL_MULTI_START_OPPONENT = 0x79f,
	ACT_DECK_IMP_DEAL_MULTI_LOOP = 0x7a0,
	ACT_DECK_IMP_DEAL_MULTI_LOOP_OPPONENT = 0x7a1,
	ACT_DECK_IMP_DEAL_MULTI_END = 0x7a2,
	ACT_DECK_IMP_DEAL_MULTI_END_OPPONENT = 0x7a3,
	ACT_DECK_IMP_10_SECS_REM_PLAYER_PLAYER = 0x7a4,
	ACT_DECK_IMP_10_SECS_REM_PLAYER_OPPONENT = 0x7a5,
	ACT_DECK_IMP_10_SECS_REM_OPPONENT_PLAYER = 0x7a6,
	ACT_DECK_IMP_10_SECS_REM_OPPONENT_OPPONENT = 0x7a7,
	ACT_DECK_IMP_0_SECS_REM_PLAYER_PLAYER = 0x7a8,
	ACT_DECK_IMP_0_SECS_REM_PLAYER_OPPONENT = 0x7a9,
	ACT_DECK_IMP_0_SECS_REM_OPPONENT_PLAYER = 0x7aa,
	ACT_DECK_IMP_0_SECS_REM_OPPONENT_OPPONENT = 0x7ab,
	ACT_DECK_IMP_REACT_SMALL_POSITIVE_PLAYER = 0x7ac,
	ACT_DECK_IMP_REACT_SMALL_POSITIVE_OPPONENT = 0x7ad,
	ACT_DECK_IMP_REACT_SMALL_NEGATIVE_PLAYER = 0x7ae,
	ACT_DECK_IMP_REACT_SMALL_NEGATIVE_OPPONENT = 0x7af,
	ACT_DECK_IMP_REACT_BROAD_POSITIVE_PLAYER = 0x7b0,
	ACT_DECK_IMP_REACT_BROAD_POSITIVE_OPPONENT = 0x7b1,
	ACT_DECK_IMP_REACT_BROAD_NEGATIVE_PLAYER = 0x7b2,
	ACT_DECK_IMP_REACT_BROAD_NEGATIVE_OPPONENT = 0x7b3,
	ACT_DECK_IMP_REACT_HERO_DEATH_POSITIVE_PLAYER = 0x7b4,
	ACT_DECK_IMP_REACT_HERO_DEATH_POSITIVE_OPPONENT = 0x7b5,
	ACT_DECK_IMP_REACT_HERO_DEATH_NEGATIVE_PLAYER = 0x7b6,
	ACT_DECK_IMP_REACT_HERO_DEATH_NEGATIVE_OPPONENT = 0x7b7,
	ACT_DECK_IMP_REACT_CONFUSED_POSITIVE_PLAYER = 0x7b8,
	ACT_DECK_IMP_REACT_CONFUSED_POSITIVE_OPPONENT = 0x7b9,
	ACT_DECK_IMP_REACT_CONFUSED_NEGATIVE_PLAYER = 0x7ba,
	ACT_DECK_IMP_REACT_CONFUSED_NEGATIVE_OPPONENT = 0x7bb,
	ACT_DECK_IMP_TEST_ANIMATION_PLAYER = 0x7bc,
	ACT_DECK_IMP_TEST_ANIMATION_OPPONENT = 0x7bd,
	ACT_DECK_IMP_CUSTOM_CARD_SILENCE_PLAYER = 0x7be,
	ACT_DECK_IMP_CUSTOM_CARD_SILENCE_OPPONENT = 0x7bf,
	ACT_DECK_IMP_CUSTOM_CARD_STUN_PLAYER = 0x7c0,
	ACT_DECK_IMP_CUSTOM_CARD_STUN_OPPONENT = 0x7c1,
	ACT_DECK_IMP_REACT_SMALL_DISGUST_PLAYER = 0x7c2,
	ACT_DECK_IMP_REACT_SMALL_DISGUST_OPPONENT = 0x7c3,
	ACT_DECK_IMP_CUSTOM_CARD_ATTACKBUFF_PLAYER = 0x7c4,
	ACT_DECK_IMP_CUSTOM_CARD_ARMORBUFF_PLAYER = 0x7c5,
	ACT_DECK_IMP_CUSTOM_CARD_CLEAVEBUFF_PLAYER = 0x7c6,
	ACT_DECK_IMP_CUSTOM_CARD_PIERCEBUFF_PLAYER = 0x7c7,
	ACT_DECK_IMP_CUSTOM_CARD_SIEGEBUFF_PLAYER = 0x7c8,
	ACT_DECK_IMP_CUSTOM_CARD_HEALBUFF_PLAYER = 0x7c9,
	ACT_DECK_IMP_CUSTOM_CARD_HEALBUFF_PLAYER_FLASK = 0x7ca,
	ACT_DECK_IMP_CUSTOM_CARD_IMMUNEBUFF_PLAYER = 0x7cb,
	ACT_DECK_IMP_CUSTOM_CARD_IMMUNEBUFF_OPPONENT = 0x7cc,
	ACT_DECK_IMP_REACT_BLOCKED_PLAYER = 0x7cd,
	ACT_DECK_IMP_REACT_NOTBLOCKED_PLAYER = 0x7ce,
	ACT_DECK_IMP_REACT_PLAYER_TOWER_DESTROYED_PLAYER = 0x7cf,
	ACT_DECK_IMP_POKED_PLAYER = 0x7d0,
	ACT_DECK_IMP_BLINK_RETURN_PLAYER = 0x7d1,
	ACT_DECK_IMP_CARD_PLAYED_POSITIVE_PLAYER = 0x7d2,
	ACT_DECK_IMP_CARD_PLAYED_NEGATIVE_PLAYER = 0x7d3,
	ACT_DECK_IMP_REACT_OPPONENT_PAUSE_START = 0x7d4,
	ACT_DECK_IMP_REACT_OPPONENT_PAUSE_LOOP = 0x7d5,
	ACT_DECK_IMP_REACT_OPPONENT_PAUSE_END = 0x7d6,
	ACT_DECK_IMP_REACT_PLAYER_PAUSE_START = 0x7d7,
	ACT_DECK_IMP_REACT_PLAYER_PAUSE_LOOP = 0x7d8,
	ACT_DECK_IMP_REACT_PLAYER_PAUSE_END = 0x7d9,
	ACT_DECK_IMP_REACT_VICTORY = 0x7da,
	ACT_DECK_IMP_REACT_DEFEAT = 0x7db,
	ACT_DECK_IMP_REACT_WAIT_PLAYER = 0x7dc,
	ACT_DECK_IMP_REACT_WAIT_OPPONENT = 0x7dd,
	ACT_DECK_IMP_REACT_VICTORY_OPPONENT = 0x7de,
	ACT_DECK_IMP_REACT_DEFEAT_OPPONENT = 0x7df,
	ACT_DECK_IMP_CUSTOM_CARD_ATTACKBUFF_OPPONENT = 0x7e0,
	ACT_DECK_IMP_CUSTOM_CARD_ARMORBUFF_OPPONENT = 0x7e1,
	ACT_DECK_IMP_CUSTOM_CARD_CLEAVEBUFF_OPPONENT = 0x7e2,
	ACT_DECK_IMP_CUSTOM_CARD_PIERCEBUFF_OPPONENT = 0x7e3,
	ACT_DECK_IMP_CUSTOM_CARD_SIEGEBUFF_OPPONENT = 0x7e4,
	ACT_DECK_IMP_CUSTOM_CARD_HEALBUFF_OPPONENT = 0x7e5,
	ACT_DECK_IMP_CUSTOM_CARD_HEALBUFF_OPPONENT_FLASK = 0x7e6,
	ACT_DECK_IMP_PLAYCARD_GENERIC_POSITIVE_PLAYER = 0x7e7,
	ACT_DECK_IMP_PLAYCARD_GENERIC_NEGATIVE_PLAYER = 0x7e8,
	ACT_DECK_IMP_PLAYCARD_GENERIC_POSITIVE_OPPONENT = 0x7e9,
	ACT_DECK_IMP_PLAYCARD_GENERIC_NEGATIVE_OPPONENT = 0x7ea,
	ACT_DECK_IMP_REACT_OPPONENT_NO_PLAYER_UNITS = 0x7eb,
	ACT_DECK_IMP_REACT_LOCAL_TOWER_DAMAGE_PLAYER = 0x7ec,
	ACT_DECK_IMP_BLUE_BUTTON_POSITIVE_PLAYER = 0x7ed,
	ACT_DECK_IMP_BLUE_BUTTON_POSITIVE_OPPONENT = 0x7ee,
	ACT_DECK_IMP_FINISH_DEPLOY_INTRO = 0x7ef,
	ACT_DECK_IMP_FINISH_DEPLOY_LOOP = 0x7f0,
	ACT_DECK_IMP_FINISH_DEPLOY_OUTRO = 0x7f1,
	ACT_DECK_IMP_IDLE_WINNING_PLAYER = 0x7f2,
	ACT_DECK_IMP_IDLE_WINNING_OPPONENT = 0x7f3,
	ACT_DECK_IMP_IDLE_OPPONENT_WINNING_OPPONENT_INTRO = 0x7f4,
	ACT_DECK_IMP_IDLE_OPPONENT_WINNING_OPPONENT_LOOP = 0x7f5,
	ACT_DECK_IMP_IDLE_LOSING_INTRO_PLAYER = 0x7f6,
	ACT_DECK_IMP_IDLE_LOSING_LOOP_PLAYER = 0x7f7,
	ACT_DECK_IMP_IDLE_LOSING_OPPONENT = 0x7f8,
	ACT_DECK_IMP_REACT_PLAYER_WHATEVER = 0x7f9,
	ACT_DECK_IMP_REACT_OPPONENT_WHATEVER = 0x7fa,
	ACT_DECK_IMP_REACT_PLAYER_CARD_SWAP = 0x7fb,
	ACT_DECK_IMP_REACT_LOCAL_TOWER_GAINED_SKULL_PLAYER = 0x7fc,
	ACT_DECK_IMP_REACT_OPPONENT_TOWER_GAINED_SKULL_PLAYER = 0x7fd,
	ACT_DECK_IMP_REACT_LOCAL_TOWER_HAS_DEATH_SKULL_IDLE_PLAYER = 0x7fe,
	ACT_DECK_IMP_REACT_LOCAL_TOWER_HAS_DEATH_SKULL_IDLE_OPPONENT = 0x7ff,
	ACT_DECK_IMP_REACT_OPPONENT_TOWER_HAS_DEATH_SKULL_IDLE_PLAYER = 0x800,
	ACT_DECK_IMP_REACT_OPPONENT_TOWER_HAS_DEATH_SKULL_IDLE_OPPONENT = 0x801,
	ACT_DECK_IMP_REACT_LOCAL_TOWER_GAINED_DEATH_SKULL_OPPONENT = 0x802,
	ACT_DECK_IMP_LOCAL_REMOVED_DEATH_SKULL_POSITIVE_PLAYER = 0x803,
	ACT_DECK_IMP_REMOVED_DEATH_SKULL_POSITIVE_OPPONENT = 0x804,
	ACT_DECK_IMP_PLAYERISCONFUSED_OPPONENT = 0x805,
	ACT_DECK_IMP_PLAYERISCONFUSED_PLAYER = 0x806,
	ACT_DECK_IMP_OPPONENTISCONFUSED_OPPONENT = 0x807,
	ACT_DECK_IMP_OPPONENTISCONFUSED_PLAYER = 0x808,
	ACT_DECK_IMP_REACT_NO_LOCAL_UNITS_PLAYER = 0x809,
	ACT_DECK_IMP_REACT_NO_LOCAL_UNITS_OPPONENT = 0x80a,
	ACT_DECK_IMP_REACT_NO_OPPONENT_UNITS_PLAYER = 0x80b,
	ACT_DECK_IMP_REACT_NO_OPPONENT_UNITS_OPPONENT = 0x80c,
	ACT_DECK_IMP_REACT_NO_LOCAL_UNITS_IDLE_LOOP_PLAYER = 0x80d,
	ACT_DECK_IMP_REACT_NO_LOCAL_UNITS_IDLE_LOOP_OPPONENT = 0x80e,
	ACT_DECK_IMP_REACT_NO_OPPONENT_UNITS_IDLE_LOOP_PLAYER = 0x80f,
	ACT_DECK_IMP_REACT_NO_OPPONENT_UNITS_IDLE_LOOP_OPPONENT = 0x810,
	ACT_DECK_IMP_TOWN_PORTAL_PLAYER = 0x811,
	ACT_DECK_IMP_SUMMON_IMPROVEMENT_POSITIVE_PLAYER = 0x812,
	ACT_DECK_IMP_LOCAL_TOWER_DESTROYED_PLAYER = 0x813,
	ACT_DECK_IMP_LOCAL_TOWER_DESTROYED_OPPONENT = 0x814,
	ACT_DECK_IMP_OPPONENT_TOWER_DESTROYED_PLAYER = 0x815,
	ACT_DECK_IMP_OPPONENT_TOWER_DESTROYED_OPPONENT = 0x816,
	ACT_DECK_IMP_TAUNT_CARD_PLAYER = 0x817,
	ACT_DECK_IMP_SILENCED_PLAYER = 0x818,
	ACT_DECK_IMP_BLINK_RETURN_LOCAL_NEGATIVE = 0x819,
	ACT_DECK_IMP_VS_DISPLAY_HERO_CARDS_LOCAL = 0x81a,
	ACT_DECK_IMP_VS_DISPLAY_HERO_CARDS_IDLE_LOCAL = 0x81b,
	ACT_DECK_IMP_VS_DISPLAY_HERO_CARDS_EXIT_LOCAL = 0x81c,
	ACT_DECK_IMP_VS_DISPLAY_HERO_CARDS_OPPONENT = 0x81d,
	ACT_DECK_IMP_VS_DISPLAY_HERO_CARDS_IDLE_OPPONENT = 0x81e,
	ACT_DECK_IMP_VS_DISPLAY_HERO_CARDS_EXIT_OPPONENT = 0x81f,
	ACT_DECK_IMP_VS_DISPLAY_HERO_CARDS_CARD_TREE = 0x820,
	ACT_DECK_IMP_VS_DISPLAY_HERO_CARDS_IDLE_CARD_TREE = 0x821,
	ACT_DECK_IMP_VS_DISPLAY_HERO_CARDS_EXIT_CARD_TREE = 0x822,
	ACT_DCG_BOARDSKELETON_CLOSED = 0x823,
	ACT_DCG_BOARDSKELETON_OPENING = 0x824,
	ACT_DCG_BOARDSKELETON_OPEN = 0x825,
	ACT_DECK_IMP_INITIAL_FLOP_LAYOUT_LOCAL = 0x826,
	ACT_DECK_IMP_INITIAL_FLOP_LAYOUT_OPPONENT = 0x827,
	ACT_DECK_IMP_INITIAL_FLOP_LAYOUT_CAMERA = 0x828,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_POSITIVE_PLAYER = 0x829,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_POSITIVE_OPPONENT = 0x82a,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_NEGATIVE_PLAYER = 0x82b,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_NEGATIVE_OPPONENT = 0x82c,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_NEGATIVE_COWER_PLAYER = 0x82d,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_NEGATIVE_COWER_OPPONENT = 0x82e,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_NEGATIVE_DISGUST_PLAYER = 0x82f,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_NEGATIVE_DISGUST_PLAYER_UNDERGROUND = 0x830,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_DISGUST_OPPONENT = 0x831,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_NEGATIVE_HIDE_PLAYER = 0x832,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_HIDE_OPPONENT = 0x833,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_GROUND_SHAKE_POSITIVE_PLAYER = 0x834,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_GROUND_SHAKE_NEGATIVE_PLAYER = 0x835,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_GROUND_SHAKE_POSITIVE_OPPONENT = 0x836,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_GROUND_SHAKE_NEGATIVE_OPPONENT = 0x837,
	ACT_DECK_IMP_PLAYCARD_RAZZLE_A_NEGATIVE_HIDE_OPPONENT = 0x838,
	ACT_DECK_IMP_PLAYCARD_SET_1_RAZZLE_A_POSITIVE_DUEL_PLAYER = 0x839,
	ACT_DECK_IMP_PLAYCARD_SET_1_RAZZLE_A_DUEL_OPPONENT = 0x83a,
	ACT_DECK_IMP_PLAYCARD_SET_1_RAZZLE_A_LEGION_SUMMON_PLAYER = 0x83b,
	ACT_DECK_IMP_PLAYCARD_SET_1_RAZZLE_A_LEGION_SUMMON_OPPONENT = 0x83c,
	ACT_DCG_ANIMATED_ATTACH_1 = 0x83d,
	ACT_DCG_ANIMATED_ATTACH_2 = 0x83e,
	ACT_DCG_ANIMATED_ATTACH_3 = 0x83f,
	ACT_DCG_ANIMATED_ATTACH_4 = 0x840,
	ACT_COIN_LOCAL_IDLE = 0x841,
	ACT_COIN_OPPONENT_IDLE = 0x842,
	ACT_COIN_TO_LOCAL = 0x843,
	ACT_COIN_TO_OPPONENT = 0x844,
	ACT_COIN_FIGHT_LOCAL = 0x845,
	ACT_COIN_FIGHT_OPPONENT = 0x846,
	ACT_COIN_SPAWN_LOCAL = 0x847,
	ACT_COIN_SPAWN_OPPONENT = 0x848,
	ACT_PLAYER_COIN_IDLE = 0x849,
	ACT_PLAYER_COIN_TURN = 0x84a,
	ACT_PLAYER_COIN_TURN_PASS = 0x84b,
	ACT_PLAYER_COIN_TURN_FIGHT = 0x84c,
	ACT_PLAYER_COIN_JIGGLE = 0x84d,
	ACT_DCG_DIE_LOCAL_IDLE = 0x84e,
	ACT_DCG_DIE_LOCAL_SPAWN = 0x84f,
	ACT_DCG_DIE_LOCAL_ACTIVATE = 0x850,
	ACT_DCG_DIE_LOCAL_DESTROYED = 0x851,
	ACT_DCG_DIE_COMBAT_LOCAL_CLASH = 0x852,
	ACT_DCG_DIE_COMBAT_LOCAL_RETURN = 0x853,
	ACT_DCG_TILE_LOCAL_IDLE = 0x854,
	ACT_DCG_TILE_LOCAL_SPAWN = 0x855,
	ACT_DCG_TILE_LOCAL_DESTROYED = 0x856,
	ACT_DCG_TILE_COMBAT_LOCAL_CLASH = 0x857,
	ACT_DCG_TILE_COMBAT_LOCAL_WAIT = 0x858,
	ACT_DCG_IMPROVEMENT_IDLE = 0x859,
	ACT_DCG_IMPROVEMENT_SPAWN = 0x85a,
	ACT_DCG_IMPROVEMENT_READY = 0x85b,
	ACT_DCG_IMPROVEMENT_TRIGGERING = 0x85c,
	ACT_DCG_IMPROVEMENT_DEATH = 0x85d,
	ACT_DCG_IMPROVEMENT_ACTIVATED = 0x85e,
	ACT_DCG_IMPROVEMENT_TARGETING = 0x85f,
	ACT_DCG_IMPROVEMENT_CARD_IDLE = 0x860,
	ACT_DCG_ANCIENT_DESTROYED = 0x861,
	ACT_DCG_ANCIENT_SPAWN = 0x862,
	ACT_DCG_ANCIENT_SPAWN_LOCAL = 0x863,
	ACT_DCG_ANCIENT_SPAWN_OPPONENT = 0x864,
	ACT_DCG_ANCIENT_IDLE = 0x865,
	ACT_PLAYER_MATCH_CLOCK_IDLE = 0x866,
};

// Aligment: 4
// Size: 13
enum class EGameZone : uint32_t
{
	DCG_ZONE_INVALID = 0x0,
	DCG_ZONE_GRAVEYARD = 0x1,
	DCG_ZONE_DECK = 0x2,
	DCG_ZONE_HAND = 0x3,
	DCG_ZONE_FOUNTAIN = 0x4,
	DCG_ZONE_DEPLOYMENT = 0x5,
	DCG_ZONE_COMBAT = 0x6,
	DCG_ZONE_SPELL_STACK = 0x7,
	DCG_ZONE_SHOP = 0x8,
	DCG_ZONE_EFFECTS = 0x9,
	DCG_ZONE_IMPROVEMENTS = 0xa,
	DCG_ZONE_LIFEBOAT = 0xb,
	DCG_ZONE_COUNT = 0xc,
};

// Aligment: 0
// Size: 2104
class CDCGRuleEntity_EquippedItem : public CDCGCompositeStateRuleEntity, CDCGCardAttachEntity, CDCGAttachEntity, CDCGEntity, C_BaseAnimating, C_BaseModelEntity, C_BaseEntity, C_GameEntity, CEntityInstance, IHandleEntity
{
public:
// <no members described>
};

// Aligment: 0
// Size: 2104
class CDCGRuleEntity_IsCloned : public CDCGCompositeStateRuleEntity, CDCGCardAttachEntity, CDCGAttachEntity, CDCGEntity, C_BaseAnimating, C_BaseModelEntity, C_BaseEntity, C_GameEntity, CEntityInstance, IHandleEntity
{
public:
// <no members described>
};

// Aligment: 0
// Size: 2104
class CDCGRuleEntity_HiddenStatMod : public CDCGCompositeStateRuleEntity, CDCGCardAttachEntity, CDCGAttachEntity, CDCGEntity, C_BaseAnimating, C_BaseModelEntity, C_BaseEntity, C_GameEntity, CEntityInstance, IHandleEntity
{
public:
// <no members described>
};

// Aligment: 2
// Size: 1936
class CDCGGenericPerformerEntity : public CDCGEntity, C_BaseAnimating, C_BaseModelEntity, C_BaseEntity, C_GameEntity, CEntityInstance, IHandleEntity
{
public:
	int32_t m_nOwnerID; // 0x750
	int32_t m_nLaneID; // 0x754
};

// Aligment: 2
// Size: 968
class CDCGLocatorInfo : public C_BaseEntity, C_GameEntity, CEntityInstance, IHandleEntity
{
public:
	int32_t m_nLaneID; // 0x3c0
	bool m_bLocalPlayer; // 0x3c4
};

// Aligment: 0
// Size: 968
class C_PortraitWorldCallbackHandler : public C_BaseEntity, C_GameEntity, CEntityInstance, IHandleEntity
{
public:
// <no members described>
};

// Aligment: 3
// Size: 3272
class CDCG_PortraitWorldUnit : public CDCGCardViewInspect, CDCGCardView, CDCGEntity, C_BaseAnimating, C_BaseModelEntity, C_BaseEntity, C_GameEntity, CEntityInstance, IHandleEntity
{
public:
	bool m_bDeferredPortrait; // 0xc94
	CUtlString m_cameraName; // 0xc98
	float m_flCardSizeRatio; // 0xcac
};

// Aligment: 1
// Size: 968
class C_DCGGameRulesProxy : public C_GameRulesProxy, C_BaseEntity, C_GameEntity, CEntityInstance, IHandleEntity
{
public:
	// MNetworkEnable
	// MNetworkEnable
	// MNetworkPriority "64"
	C_SingleplayRules* m_pGameRules; // 0x3c0
};

// Aligment: 11
// Size: 1576
class CDCGWorldParticleSystem : public C_BaseModelEntity, C_BaseEntity, C_GameEntity, CEntityInstance, IHandleEntity
{
public:
	int32_t m_nType; // 0x5e8
	int32_t m_iClientEffectIndex; // 0x5ec
	CUtlSymbolLarge m_szEffectName; // 0x5f0
	CUtlSymbolLarge m_szTargetName; // 0x5f8
	CUtlSymbolLarge m_szControlPoint; // 0x600
	HSequence m_hOverrideSequence; // 0x608
	CStrongHandle< InfoForResourceTypeCModel > m_hOverrideModel; // 0x610
	Vector m_vModelScale; // 0x618
	bool m_bDayTime; // 0x624
	bool m_bNightTime; // 0x625
	bool m_bShowInFow; // 0x626
};

// Aligment: 43
// Size: 1168
class CGlobalLightBase
{
public:
	bool m_bSpotLight; // 0x10
	Vector m_SpotLightOrigin; // 0x14
	QAngle m_SpotLightAngles; // 0x20
	Vector m_ShadowDirection; // 0x2c
	Vector m_AmbientDirection; // 0x38
	Vector m_SpecularDirection; // 0x44
	Vector m_InspectorSpecularDirection; // 0x50
	float m_flSpecularPower; // 0x5c
	float m_flSpecularIndependence; // 0x60
	Color m_SpecularColor; // 0x64
	bool m_bStartDisabled; // 0x68
	bool m_bEnabled; // 0x69
	Color m_LightColor; // 0x6a
	Color m_AmbientColor1; // 0x6e
	Color m_AmbientColor2; // 0x72
	Color m_AmbientColor3; // 0x76
	float m_flSunDistance; // 0x7c
	float m_flFOV; // 0x80
	float m_flNearZ; // 0x84
	float m_flFarZ; // 0x88
	bool m_bEnableShadows; // 0x8c
	bool m_bOldEnableShadows; // 0x8d
	bool m_bBackgroundClearNotRequired; // 0x8e
	float m_flCloudScale; // 0x90
	float m_flCloud1Speed; // 0x94
	float m_flCloud1Direction; // 0x98
	float m_flCloud2Speed; // 0x9c
	float m_flCloud2Direction; // 0xa0
	float m_flAmbientScale1; // 0xa4
	float m_flAmbientScale2; // 0xa8
	float m_flGroundScale; // 0xac
	float m_flLightScale; // 0xb0
	float m_flFoWDarkness; // 0xb4
	bool m_bEnableSeparateSkyboxFog; // 0xb8
	Vector m_vFowColor; // 0xbc
	Vector m_ViewOrigin; // 0xc8
	QAngle m_ViewAngles; // 0xd4
	float m_flViewFoV; // 0xe0
	Vector[8] m_WorldPoints; // 0xe4
	Vector2D m_vFogOffsetLayer0; // 0x478
	Vector2D m_vFogOffsetLayer1; // 0x480
	CHandle< C_BaseEntity > m_hEnvWind; // 0x488
	CHandle< C_BaseEntity > m_hEnvSky; // 0x48c
};

// Aligment: 1
// Size: 2168
class C_GlobalLight : public C_BaseEntity, C_GameEntity, CEntityInstance, IHandleEntity
{
public:
	uint16_t m_WindClothForceHandle; // 0x850
public:
	static C_GlobalLight*[5] &Get_sm_pGlobalLight() { return *reinterpret_cast<C_GlobalLight*[5]*>(interfaces::g_schema->FindTypeScopeForModule("client.dll")->FindDeclaredClass("C_GlobalLight")->m_static_fiels[0]->m_instance); }
	static CUtlStringToken[5] &Get_sm_pSkyboxSlots() { return *reinterpret_cast<CUtlStringToken[5]*>(interfaces::g_schema->FindTypeScopeForModule("client.dll")->FindDeclaredClass("C_GlobalLight")->m_static_fiels[1]->m_instance); }
	static CUtlVector< C_GlobalLight* > &Get_sm_nonPrimaryGlobalLights() { return *reinterpret_cast<CUtlVector< C_GlobalLight* >*>(interfaces::g_schema->FindTypeScopeForModule("client.dll")->FindDeclaredClass("C_GlobalLight")->m_static_fiels[2]->m_instance); }
};

// Aligment: 0
// Size: 1920
class C_EnvDeferredLightClientOnly : public C_EnvDeferredLight, C_ModelPointEntity, C_BaseModelEntity, C_BaseEntity, C_GameEntity, CEntityInstance, IHandleEntity
{
public:
// <no members described>
};

// Aligment: 1
// Size: 56
class CScriptComponent : public CEntityComponent
{
public:
	CUtlSymbolLarge m_scriptClassName; // 0x30
public:
	static EntComponentInfo_t &Get_s_EntComponentInfo() { return *reinterpret_cast<EntComponentInfo_t*>(interfaces::g_schema->FindTypeScopeForModule("client.dll")->FindDeclaredClass("CScriptComponent")->m_static_fiels[0]->m_instance); }
	static int32_t &Get_entity_component_error_class_decl_says_contained_but_impl_is_referenced() { return *reinterpret_cast<int32_t*>(interfaces::g_schema->FindTypeScopeForModule("client.dll")->FindDeclaredClass("CScriptComponent")->m_static_fiels[1]->m_instance); }
};

